package cn.com.qmth.examcloud.exchange.outer.service.impl;

import java.io.File;
import java.io.IOException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.exchange.outer.service.UpyunService;
import main.java.com.UpYun;

/**
 * Created by yuanpan on 2017/5/11.
 */
@Service
public class UpyunServiceImpl implements UpyunService {

	private final Object LOCK = new Object();

	private UpYun upyun;

	@Value("${app.upyun.path}")
	private String path;

	@Value("${app.upyun.bucket}")
	private String bucket;

	@Value("${app.upyun.operator}")
	private String operator;

	@Value("${app.upyun.password}")
	private String password;

	private UpYun getUpyun() {
		// modified by wangwei.
		if (null == upyun) {
			synchronized (LOCK) {
				if (null == upyun) {
					upyun = new UpYun(bucket, operator, password);
				}
			}
		}
		return upyun;
	}

	public String getDownloadUrl(String identityNumber, String fileName, String fileSuffix) {

		if (fileSuffix.startsWith(".")) {
			return "http://" + bucket + ".b0.upaiyun.com/student_base_photo/" + identityNumber + "/"
					+ fileName + "" + fileSuffix;
		} else {
			return "http://" + bucket + ".b0.upaiyun.com/student_base_photo/" + identityNumber + "/"
					+ fileName + "." + fileSuffix;
		}

	}

	public String getMd5(byte[] bytes) throws NoSuchAlgorithmException {
		// 用来计算md5摘要的
		char[] hexDigits = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b',
				'c', 'd', 'e', 'f'};

		MessageDigest md5 = MessageDigest.getInstance("MD5");
		md5.update(bytes);

		byte[] md5DigestBytes = md5.digest();
		int dlen = md5DigestBytes.length;

		char[] md5val = new char[dlen * 2];
		int k = 0;
		for (byte encoded : md5DigestBytes) {
			md5val[k++] = hexDigits[encoded >> 4 & 15];
			md5val[k++] = hexDigits[encoded & 5];
		}

		return new String(md5val);
	}

	public boolean saveStudentPhoto(String identityNumber, byte[] bytes, String fileName,
			String fileSuffix) throws IOException {

		if (fileSuffix.startsWith(".")) {
			return getUpyun().writeFile(path + "/" + identityNumber + "/" + fileName + fileSuffix,
					bytes, true);
		} else {
			return getUpyun().writeFile(
					path + "/" + identityNumber + "/" + fileName + "." + fileSuffix, bytes, true);
		}

	}

	@Override
	public String saveStudentPhoto(String identityNumber, Long rootOrgId, String fileSuffix,
			File file) {
		String filePath = path + "/" + rootOrgId + "/" + identityNumber + "/"
				+ System.currentTimeMillis();
		if (fileSuffix.startsWith(".")) {
			filePath += fileSuffix;
		} else {
			filePath += "." + fileSuffix;
		}
		try {
			getUpyun().writeFile(filePath, file, true);
			return filePath;
		} catch (Exception e) {
			throw new StatusException("EX-100001", "调用又拍云API写文件失败");
		}
	}

	@Override
	public String saveStudentPhoto(String identityNumber, Long rootOrgId, String fileSuffix,
			byte[] bytes) {
		String filePath = path + "/" + rootOrgId + "/" + identityNumber + "/"
				+ System.currentTimeMillis();
		if (fileSuffix.startsWith(".")) {
			filePath += fileSuffix;
		} else {
			filePath += "." + fileSuffix;
		}
		try {
			getUpyun().writeFile(filePath, bytes, true);
			return filePath;
		} catch (Exception e) {
			throw new StatusException("EX-100001", "调用又拍云API写文件失败");
		}
	}
}
